//+------------------------------------------------------------------+
//|																								 CreatePattern.mq4 |
//|																									   |
//+------------------------------------------------------------------+
#include <WinUser32.mqh>

//   
extern string ="MA25_15"; //    

//    
#define NUM_BAR		6000 //     (  )
#define NUM_MA		5 //  
#define DEPTH_MA	3 //   
#define NUM_OUT		1 //  

double MaIn[NUM_MA][DEPTH_MA]; //   
int hFile;
//------------------------------------------------------------------ deinit
int deinit() { return(0); }
//------------------------------------------------------------------ start
int start() 
{
	string FileName = +".in";	
	//   
	hFile = FileOpen(FileName, FILE_READ|FILE_BIN);
	if (hFile!=-1)
	{
		if (MessageBox(" "+FileName+" . ?", "!", MB_YESNO|MB_ICONQUESTION)==IDNO)
			return(0);	//    ,  
	}
	//  
	hFile = FileOpen(FileName, FILE_WRITE|FILE_BIN);
	FileSeek(hFile, 0, SEEK_END);

	//   
	FileWriteInteger(hFile, NUM_BAR); //    
	FileWriteInteger(hFile, NUM_MA*DEPTH_MA); //     (  )
	FileWriteInteger(hFile, NUM_OUT); //  
	SaveInputPattern();//    
	SaveOutPattern(); //   
	FileClose(hFile);
	return(0);
}
//------------------------------------------------------------------ CreateInputPattern
void SaveInputPattern() //      
{
	Comment("  ");
	FileSeek(hFile, 0, SEEK_END);
	int i, ma, depth;
	double op, E;
	for (i=NUM_BAR; i>0; i--) //         
	{
		E=0.0;
		for (depth=0; depth<DEPTH_MA; depth++) //  
			for (ma=0; ma<NUM_MA; ma++) 
			{
				MaIn[ma][depth]=iMA(NULL, 0, 2+MathSqrt(ma*ma*ma)*3, 0, MODE_EMA, PRICE_MEDIAN, i+depth*depth)-((High[i+depth*depth]+Low[i+depth*depth])/2);
				E=E+MaIn[ma][depth]*MaIn[ma][depth]; //     
			}
		E=MathSqrt(E); //     
		for (depth=0; depth<DEPTH_MA; depth++) //     
			for (ma=0; ma<NUM_MA; ma++) 
			{
				op=MaIn[ma][depth]/E;
				FileWriteDouble(hFile, op);
			}
	}
}
//------------------------------------------------------------------ CreateOutPattern
void SaveOutPattern() //      
{
	Comment("  ");
	FileSeek(hFile, 0, SEEK_END);
	double Up, Dn, op;
	int i;
	for (i=NUM_BAR; i>0; i--) //      
	{
		op=2.0;
		FileWriteDouble(hFile, op);
	}
}

